import { InvoiceTempalte } from '../invoice.template';
const PdfPrinter = require('pdfmake');
const { PassThrough } = require('stream');

export async function GeneratePdf(transaction, invoiceType, banks) {
  var fonts = {
    Roboto: {
      normal: './fonts/Roboto-Regular.ttf',
      bold: './fonts/Roboto-Medium.ttf',
      italics: './fonts/Roboto-Italic.ttf',
      bolditalics: './fonts/Roboto-MediumItalic.ttf',
    },
  };

  const printer = new PdfPrinter(fonts);

  const docDefinition = InvoiceTempalte(transaction, invoiceType, banks);

  const createPdfBuffer = (docDefinition) => {
    return new Promise((resolve, reject) => {
      const pdfDoc = printer.createPdfKitDocument(docDefinition);
      const chunks = [];
      const stream = new PassThrough();

      pdfDoc.pipe(stream);
      pdfDoc.end();

      stream.on('data', (chunk) => {
        chunks.push(chunk);
      });

      stream.on('end', () => {
        const pdfBuffer = Buffer.concat(chunks);
        resolve(pdfBuffer);
      });

      stream.on('error', reject);
    });
  };

  const pdfBuffer = await createPdfBuffer(docDefinition);
  return pdfBuffer;
}
